SSS = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
local L = AceLibrary("AceLocale-2.2"):new("SSS")

SSS.soulstone_loc = L["Soulstone Resurrection"]
--SSS.soulstone_loc = "Unendlicher Atem"
--SSS.debug = true

SSS:RegisterDB("SSSDB", "SSSDBPC")
SSS:RegisterDefaults("char", {  point = "LEFT",
				x = 30,
				y = 200,
				message_start = L["places her soulstone on #t."],
				message_interrupt = L["I failed to put a soulstone on #t."],
				message_success = L["I successfully placed a soulstone on #t."],
				channel_start = "EMOTE",
				channel_interrupt = "RAID",
				channel_success = "RAID",
				showmessage_start = true,
				showmessage_interrupt = false,
				showmessage_success = false,
				list_channel = "",
				show_display_raid = true,
				show_display_party = false,
				display_sources = false,
				display_flag = true})
				

SSS.options = {
	type = "group",
	args = {
			message = {
				type = "group",
				name = L["Message"],
				desc = L["This menu contains options for the display of various messages during the casting of a soulstone."],
				order = 1,
				args = {
					start = {
						type = "group",
						name = L["Message on start"],
						desc = L["Options for the message shown when casting starts"],
						order = 1,
						args = {
							show = {
								type = "toggle",
								name = L["Show Message when casting starts"],
								desc = "-",
								order = 1,
								get = function () return SSS.db.char.showmessage_start end,
								set = function (v) SSS.db.char.showmessage_start = v end
							},
		
							message_ = {
								type = "text",
								name = L["Message shown upon start"],
								desc = L["Changes the message sent when the casting starts."],
								order = 2,
								usage = L["<new message> -- Use #t to output the targets name."],
								get = function() return SSS.db.char.message_start end,
								set = function(s) SSS.db.char.message_start = s end
							},
							
							channel = {
								type = "text",
								name = "Channel",
								order = 3,
								desc = L["Changes the channel used for the message."],
								usage = L["e.g. EMOTE, PARTY, RAID or channel number"],
								get = function() return SSS.db.char.channel_start end,
								set = function (s) SSS.db.char.channel_start = s end
							},
						}
					},
					
					interrupt = {
						type = "group",
						name = L["Message on interrupt"],
						desc = L["Options for the message shown when casting is interrupted"],
						order = 2,
						args = {
							show = {
								type = "toggle",
								name = L["Show Message when casting is interrupted"],
								desc = "-",
								order = 1,
								get = function () return SSS.db.char.showmessage_interrupt end,
								set = function (v) SSS.db.char.showmessage_interrupt = v end
							},
					
							message = {
								type = "text",
								name = L["Message shown upon interrupt"],
								desc = L["Changes the message sent when the casting is interrupted."],
								order = 2,
								usage = L["<new message> -- Use #t to output the targets name."],
								get = function() return SSS.db.char.message_interrupt end,
								set = function(s) SSS.db.char.message_interrupt = s end
							},
							
							channel = {
								type = "text",
								name = "Channel",
								desc = L["Changes the channel used for the message."],
								order = 3,
								usage = L["e.g. EMOTE, PARTY, RAID or channel number"],
								get = function() return SSS.db.char.channel_interrupt end,
								set = function (s) SSS.db.char.channel_interrupt = s end
							},

						}
					},
					
					success = {
						type = "group",
						name = L["Message on success"],
						desc = L["Options for the message shown when casting is successful"],
						order = 3,
						args = {
							show = {
								type = "toggle",
								name = L["Show Message when casting is successful"],
								desc = "-",
								order = 1,
								get = function () return SSS.db.char.showmessage_success end,
								set = function (v) SSS.db.char.showmessage_success = v end
							},
					
							message = {
								type = "text",
								name = L["Message shown upon success"],
								desc = L["Changes the message sent when the casting is successful."],
								order = 2,
								usage = L["<new message> -- Use #t to output the targets name."],
								get = function() return SSS.db.char.message_success end,
								set = function(s) SSS.db.char.message_success = s end
							},
							
							channel = {
								type = "text",
								name = "Channel",
								desc = L["Changes the channel used for the message."],
								order = 3,
								usage = L["e.g. EMOTE, PARTY, RAID or channel number"],
								get = function() return SSS.db.char.channel_success end,
								set = function (s) SSS.db.char.channel_success = s end
							},

						}
					},
				},
			},
			

						
			list = {
				type = "group",
				name = L["Soulstone list"],
				desc = L["Options to print a list of soulstones"],
				order = 3,
				args = {
					print = {
						type = "execute",
						name = L["Print"],
						desc = L["Prints a list of known soulstones."],
						order = 1,
						func = function () SSS:List() end,
					},
					
					channel = {
						type = "text",
						name = L["Channel"],
						order = 2,
						usage = L["e.g. EMOTE, PARTY, RAID or channel number"],
						desc = L["Changes the channel used for the message."],
						get = function () return SSS.db.char.list_channel end,
						set = function (s) SSS.db.char.list_channel = s end
					}
				}
			},
			
			display = {
				type = "group",
				name = "Show",
				desc = L["Display options"],
				order = 2,
				args = {
					raid = { 
						type = "toggle",
						name = L["Show in raid"],
						desc = L["Show the list of soulstones when in a raid."],
						get = function() return SSS.db.char.show_display_raid end,
						set = function(s) SSS.db.char.show_display_raid = s end
					},

					party = { 
						type = "toggle",
						name = L["Show in party"],
						desc = L["Show the list of soulstones when in a party."],
						get = function() return SSS.db.char.show_display_party end,
						set = function(s) SSS.db.char.show_display_party = s end
					},
					
					sources = {
						type = "toggle",
						name = L["Show sources"],
						desc = L["Show the sources of soulstones"],
						get = function() return SSS.db.char.display_sources end,
						set = function(v) SSS.db.char.display_sources = v end
					},
					
					flag_own = {
						type = "toggle",
						name = L["Flag own soulstone"],
						desc = L["Marks your own soulstone"],
						get = function() return SSS.db.char.display_flag end,
						set = function(v) SSS.db.char.display_flag = v end
					}
						
				}
			}
		}
}



function SSS:Debug(...)
	if self.debug then self:Print(...) end
end


function SSS:OnEnable()

-- for storing spell info (for interrupt and success messages)
	self.spellname = ""
	self.target = ""

-- for storing set soulstones and... uhm... possible ones =)
	self.soulstones = {}
	self.warlocks = {}
	self.numstones = 0
	self.numwarlocks = 0
	
	self.display = CreateFrame("Frame",nil,UIParent)
	self.display:SetFrameStrata("MEDIUM")
	self.display:SetWidth(150)   
	self.display:SetHeight(32) 

	self.display:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 32, edgeSize = 16, 
                                            insets = { left = 0, right = 0, top = 0, bottom = 0 }})
	self.display:SetBackdropColor(150, 0, 150, 0)
	self.display:SetClampedToScreen(true)
	self.display:SetPoint(self.db.char.point,nil, self.db.char.point, self.db.char.x, self.db.char.y)
	self.display:SetMovable(true)
	self.display:RegisterForDrag("LeftButton")
	self.display:EnableMouse(true)
	self.display:SetScript("OnDragStart", self.display.StartMoving)
	self.display:SetScript("OnDragStop", function () SSS.display:StopMovingOrSizing(); SSS.db.char.point, _ ,_ , SSS.db.char.x, SSS.db.char.y = SSS.display:GetPoint(); end)
	

	self.display.names = self.display:CreateFontString(nil, "ARTWORK")
	self.display.names:SetFontObject(GameFontNormal)
	self.display.names:SetJustifyH("LEFT")
	self.display.names:SetTextColor(200,200,200,1)
	self.display.names:SetPoint("TOPLEFT",10,-3)
	
	self.display.sources = self.display:CreateFontString(nil, "ARTWORK") 
	self.display.sources:SetFontObject(GameFontNormal)
	self.display.sources:SetJustifyH("LEFT")
	self.display.sources:SetTextColor(200,200,200,1)
	self.display.sources:SetPoint("LEFT",self.display.names, "RIGHT",20,0)
	
	self.display.times = self.display:CreateFontString(nil, "ARTWORK")
	self.display.times:SetFontObject(GameFontNormal)
	self.display.times:SetJustifyH("RIGHT")
	self.display.times:SetTextColor(200,200,200,1)
	self.display.times:SetPoint("TOPRIGHT",-10,-3)
	
	

	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
--	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	
	self:CollectWarlocks()
	
	self:ScheduleRepeatingEvent(SSS.Update, 0.5)
	self:RegisterChatCommand({"/sss"}, self.options)
	self:Print(L["Enter /sss for a list of commands."])
end



function SSS:SendMessage(text, channel)
	if channel == "" or channel == nil then
		SSS:Print(text);
	elseif tonumber(channel) then
		SendChatMessage(text, "CHANNEL", nil, tonumber(channel))
	else 
		SendChatMessage(text, channel)
	end
end


function SSS:CollectWarlocks()
	local checker = {}
	local counter = 0
	_, class = UnitClass("player")
	if class == "WARLOCK" then
		counter = counter +1 
		checker[UnitName("player")] = 1
		if not self.warlocks[UnitName("player")] then self.warlocks[UnitName("player")] = 0 end
	end
	
	if  GetNumRaidMembers() > 0 then
		for i=1,GetNumRaidMembers() do
			_, class = UnitClass("raid"..i)
			if class == "WARLOCK"  then
				counter = counter +1 
				checker[UnitName("raid"..i)] = 1
				if not self.warlocks[UnitName("raid"..i)] then self.warlocks[UnitName("raid"..i)] = 0 end
			end
		end
	elseif GetNumPartyMembers() > 0 then
		for i=1,GetNumPartyMembers() do
			_, class = UnitClass("party"..i)
			if class == "WARLOCK" then
				counter = counter +1 
				checker[UnitName("party"..i)] = 1
				if not self.warlocks[UnitName("party"..i)] then self.warlocks[UnitName("party"..i)] = 0 end
			end
		end
	end
	
	for name, _ in pairs(self.warlocks) do
		local found = false
		for name2,_ in pairs(checker) do
			if name == name2 then found = true end
		end
		if not found then
			SSS:Debug("Removing %s from warlocks", name)
			self.warlocks[name] = nil
		end
	end
	
	self.numwarlocks = counter
end


function SSS:RAID_ROSTER_UPDATE()
	for name, stone in pairs(SSS.soulstones) do
		if not SSS:GetUnitID(name) then
			SSS:Print(L["%s has left the group."], name)
			SSS:KillStone(name)
		end
	end
	self:CollectWarlocks()
end


function SSS:PARTY_MEMBERS_CHANGED()
	for name, stone in pairs(SSS.soulstones) do
		if not SSS:GetUnitID(name) then
			SSS:Print(L["%s has left the group."], name)
			SSS:KillStone(name)
		end
	end
	self:CollectWarlocks()
end

--[[]
function SSS:COMBAT_LOG_EVENT_UNFILTERED(...)
	timestamp, event, _, sourceName, _, _, destName, _, p1, p2, p3, p4 = ...
	if event == "SPELL_AURA_APPLIED" and p2 == self.soulstone_loc then
		SSS:AddStone(destName, nil, sourceName, nil)
	end
	
end--]]
	


function SSS:UNIT_SPELLCAST_SENT(unit, name, rank, target)
	if unit == "player" then 
		self.spellname = name
		self.target = target
		if self.spellname == SSS.soulstone_loc and SSS.db.char.showmessage_start then
			local text = string.gsub(SSS.db.char.message_start, "#t", self.target)
			SSS:SendMessage(text, SSS.db.char.channel_start)
		end
	end
end



function SSS:UNIT_SPELLCAST_INTERRUPTED(unit)
	if unit ~= "player" then return end
	if self.spellname == SSS.soulstone_loc and SSS.db.char.showmessage_interrupt then
	    local text = string.gsub(SSS.db.char.message_interrupt, "#t", self.target)
		SSS:SendMessage(text, SSS.db.char.channel_interrupt)
	end
end


function SSS:UNIT_SPELLCAST_SUCCEEDED(unit, name, rang, ziel)
	if unit ~= "player" then return end
	if self.spellname == SSS.soulstone_loc  then
		if SSS.db.char.showmessage_success then
			local text = string.gsub(SSS.db.char.message_success, "#t", self.target)
			self:SendMessage(text, SSS.db.char.channel_success)
		end
	end
end


function SSS:AddStone(name, class, source, endtime)
	if string.find(name, "-") then return end
	if not SSS:GetUnitID(name) then return end
	if SSS.soulstones[name] == nil then
		SSS.numstones = SSS.numstones +1
		SSS.soulstones[name] = {}
	end
	if source ~= nil then SSS.soulstones[name]["source"] = source end
	if endtime ~= nil and endtime > 0 then
		SSS.soulstones[name]["endtime"] =  endtime
	else
		if not SSS.soulstones[name]["endtime"]  then
			SSS.soulstones[name]["endtime"] = GetTime()+30*60
		end	
	end
	if class ~= nil then SSS.soulstones[name]["class"] = class end
	SSS.soulstones[name]["status"] = "alive"
--	SSS:Debug("Soulstone added on %s with endtime %s. (class=%s, source=%s)",name ,endtime, class, source)
	SSS:UpdateDisplay()
	if SSSFu then SSSFu:UpdateText() end -- for fubar
end


function SSS:GetStones(dead)
	local count = 0
	
	for name,stone in pairs(self.soulstones or {}) do
		if stone["status"] == "alive" and not dead then count = count + 1 end
		if not stone["status"] == "alive" and dead then count = count +1 end
	end
	
	return count
end


function SSS:KillStone(name)
	SSS.soulstones[name] = nil
	SSS.numstones = SSS.numstones - 1
end

 
function SSS:GetUnitID(name)
	local unitid
	if name == UnitName("player") then
		unitid = "player"  
	elseif  GetNumRaidMembers() > 0 then
		for i=1,GetNumRaidMembers() do
			if name == UnitName("raid"..i) then unitid = "raid"..i end
		end
	elseif GetNumPartyMembers() > 0 then
		for i=1,GetNumPartyMembers() do
			if name == UnitName("party"..i) then unitid = "party"..i end
		end
	end
	return unitid
end


function SSS:RemoveStone(name)
	if SSS.soulstones[name] == nil then return end
	
--	SSS:Debug("Removing Stone on %s, status is %s. TimeLeft %s", name, self.soulstones[name]["status"], self:GetTimeLeft(name))
	
	local unitid = SSS:GetUnitID(name)
	
	
	if unitid then
	
		-- Check if this is called in error
		local  i = 1
		repeat
			buff = UnitBuff(unitid, i)
			if buff == SSS.soulstone_loc then
		--		SSS:Debug("UUps... he is not dead yet")
				SSS.soulstones[name]["status"] = "alive"
				return
			end
			i = i +1
		until not buff
		
		local isAngel
		local i = 1
		repeat
			buff, _ = UnitBuff(unitid,i)
			if buff == L["Spirit of Redemption"] then
				isAngel = true
			end
			i = i +1
		until not buff
	
--	SSS:Debug("---IsDead", UnitIsDead(unitid), "IsGhost",UnitIsGhost(unitid), "IsAngel" , isAngel)
		
		if UnitIsGhost(unitid) then
			self:KillStone(name)
			SSS:Print(L["%s did not use the soulstone."], name)
			return
		elseif UnitIsDead(unitid) or isAngel then
	--		SSS:Debug("Soul of ", name, " ist saved")
			if SSS.soulstones[name]["status"] == "alive" or SSS.soulstones[name]["status"] == "pending" or SSS.soulstones[name]["status"] == "checking" then
				if isAngel then
					SSS.soulstones[name]["status"] = "angel"
				else
					SSS.soulstones[name]["status"] = "dead"
				end
				if UnitSex(unitid)<3 then 
					SSS:Print(L["%s has died, but %s soul was saved."], name, L["his"])
				else
					SSS:Print(L["%s has died, but %s soul was saved."], name, L["her"])
				end
			end
			if SSS.soulstones[name]["status"] == "angel" and UnitIsDead(unitid) then
				SSS.soulstones[name]["status"] = "dead"
			end
		else
			if SSS.soulstones[name]["status"] == "alive" then
				self.soulstones[name]["status"] = "checking"
				return
			elseif self.soulstones[name]["status"] == "dead" then
				self:KillStone(name)
				if UnitSex(unitid)<3 then 
					SSS:Print(L["%s resurrected himself."], name)
				else
					SSS:Print(L["%s resurrected herself."], name)
				end
				return
			end
		end
	else
		-- Hmmm.. the player vanished or something...
		self:Debug("This should not happen...")
		self.soulstones[name]["status"] = "checking"
		return
	end
	
	if self.soulstones[name]["status"] == "pending" then
	--	self:Debug("Enough waiting, be done with it.")
		self:KillStone(name)
		self:Print(L["The soulstone on %s has expired."], name)
		return -- Leave here... nothing else can happen.
	end
	
	if self:GetTimeLeft(name) <= 0 or self.soulstones[name]["status"] == "checking" then
	--	self:Debug("I do not trust this... lets see what happens")
		self.soulstones[name]["status"] = "pending"
	end
	
	
	SSS:UpdateDisplay()
	if SSSFu then SSSFu:UpdateText() end-- for fubar	
end


function SSS:HasStone(name)
	return (SSS.soulstones[name] ~= nil)
end

function SSS:IsDead(name)
	if SSS.soulstones[name] == nil then return nil end
	if SSS.soulstones[name]["status"] == "angel" or SSS.soulstones[name]["status"] == "dead" then
		return true
	else
		return false
	end
end

function SSS:GetTimeLeft(name)
	if SSS.soulstones[name] == nil then return nil end
	return -(GetTime()-SSS.soulstones[name]["endtime"])
end


function SSS:GetSource(name)
	if SSS.soulstones[name] == nil then return nil end
	return SSS.soulstones[name]["source"]
end


function SSS:GetClass(name)
	if SSS.soulstones[name] == nil then return nil end
	return SSS.soulstones[name]["class"]
end

function SSS:GetStoneBySource(source)
	for _, stone in pairs(self.soulstones) do
		if stone["source"] == source then return stone end 
	end
	return nil
end


function SSS:UNIT_AURA(unit)
	local name = UnitName(unit)
	local _, class = UnitClass(unit)
	local found = false
	local source = nil
	local i = 1
	repeat
		buff, _, _, _ ,_ , _, endtime, source = UnitBuff(unit,i)
		if buff == SSS.soulstone_loc then
		    found = true
			SSS:AddStone(name, class, UnitName(source), endtime)
		end
		i = i+1
	until not buff
	if not found and self.soulstones[name] ~= nil then
		if SSS.soulstones[name]["status"] == "alive" then
			SSS:Debug("Buff not found, unit alive, checking: %s", unit)
			SSS.soulstones[name]["status"] = "checking"
		end
	end
end


function SSS:List()
	local found = false
	SSS:SendMessage("SimpleSoulstone", SSS.db.char.list_channel)
	for name, _ in pairs(SSS.soulstones or {}) do
		local time = SSS:GetTimeLeft(name)
		if time <= 0 then SSS.soulstones[name]["status"] = "checking" else
			found = true
			SSS:SendMessage(format("%s", name) .. ": " .. format("%s", date("%Mm", time)), SSS.db.char.list_channel)
	    	end
	end 
	if not found then
		SSS:SendMessage(L["There are no known soulstones."], SSS.db.char.list_channel)
	end
end



function SSS:ToggleShowMessage(v)
	self.db.char.showmessage = v
	if v then 
		self:RegisterEvent("UNIT_SPELLCAST_SENT")
	else
		self:UnregisterEvent("UNIT_SPELLCAST_SENT")
	end
end


function SSS:GetRaidColorString(class)
	local color = RAID_CLASS_COLORS[class] or {r=1,g=1,b=1}
	return "|cFF".. format("%02x%02x%02x",color.r*255, color.g*255, color.b*255)
end


function SSS:Update()
	local self = SSS
	for name, _ in pairs(SSS.soulstones or {}) do
		if self:GetTimeLeft(name) < 0  or self.soulstones[name]["status"] ~= "alive" then self:RemoveStone(name) end
	end
	
	for name, status in pairs(self.warlocks) do
		if self:GetStoneBySource(name) then
			local stone = self:GetStoneBySource(name)
			self.warlocks[name] = stone.endtime or 0
		end
	end
	self:UpdateDisplay()
end


function SSS:UpdateDisplay()
	local linestoshow = 0 
	if SSS.db.char.display_sources then
		linestoshow = math.max(SSS.numstones, SSS.numwarlocks)
		for name, stone in pairs(SSS.soulstones) do
			if not stone["source"] then linestoshow = linestoshow + 1 end
		end
	else
		linestoshow = SSS.numstones
	end
	
	if SSS.debug or (GetNumRaidMembers() > 0 and SSS.db.char.show_display_raid) or (GetNumPartyMembers() > 0 and SSS.db.char.show_display_party)   then 	
		if linestoshow > 0 and not SSS.display:IsShown() then SSS.display:Show() end
		if linestoshow == 0 and SSS.display:IsShown() then SSS.display:Hide() end
	elseif SSS.display:IsShown() then
		SSS.display:Hide()
		return
	end
	

	
	local names = ""
	local sources = SSS:GetRaidColorString("WARLOCK")
	local times = ""
	for name, _ in pairs(SSS.soulstones or {}) do
		local time = SSS:GetTimeLeft(name)
		if SSS.db.char.display_flag and SSS:GetSource(name) == UnitName("player") then names = names .. "|cFFFF0000-" end
		names = names .. SSS:GetRaidColorString(SSS:GetClass(name))..format("%s", name or "Unknown")
		if SSS.db.char.display_flag and SSS:GetSource(name) == UnitName("player") then names = names .. "|cFFFF0000-" end
		names = names .. "\n"
		sources = sources .. format("%s\n", SSS:GetSource(name) or " ")
		if SSS:IsDead(name) then
			times = times .. format("%s\n", L["dead"])
		else
			if time < 0 then
				times = times .. format("*\n")
			elseif time < 60 then
				times = times .. format("%s\n", date("%Ss", time))
			else
				times = times .. format("%s\n", date("%Mm", time))
			end
		end	
	end
	
	if not SSS.db.char.display_sources then sources = "" end -- ugly
	if SSS.db.char.display_sources then
		for name, cooldown in pairs(SSS.warlocks or {}) do
			if not SSS:GetStoneBySource(name) then
				if cooldown > GetTime() then
					names = names .. "|c77777700"..L["cooldown"].."\n"
					if cooldown -GetTime() < 60 then
						times = times .. format("%s\n", date("%Ss", cooldown -GetTime()))
					else
						times = times .. format("%s\n", date("%Mm", cooldown -GetTime()))
					end
					
				elseif cooldown == 0 then
					names = names .. "|c77777700"..L["unknown"].."\n"
					times = times .. "\n"
				else
					names = names .. "|c77777700"..L["ready"].."\n"
					times = times .. "\n"
				end
				sources = sources .. format("%s\n", name)
			end
		end
	end
	
	
	SSS.display.names:SetText(names)
	SSS.display.sources:SetText(sources)
	local size = 0
	if SSS.db.char.display_sources then
		size = math.max(SSS.display.names:GetWidth() + SSS.display.sources:GetWidth()+ 90, 150)
	else
		size = math.max(SSS.display.names:GetWidth() + 75, 150)
	end
	
	if math.abs(SSS.display:GetWidth() - size) > 5 then
		SSS.display:SetWidth(size)
	end  
	SSS.display.times:SetText(times)
	
	if math.abs(SSS.display:GetHeight() - (SSS.display.names:GetStringHeight()+6)) > 1 then
		SSS.display:SetHeight(SSS.display.names:GetStringHeight()+6)
	end
end